import { d as defineCommand, c as consola, C } from '../shared/nuxi.bd0a2fa0.mjs';
import 'node:util';
import 'node:path';
import 'node:process';
import 'node:tty';
import { o as overrideEnv } from '../shared/nuxi.2509f57e.mjs';
import { createNuxtDevServer } from './dev2.mjs';
import { s as sharedArgs, a as envNameArgs, l as legacyRootDirArgs, r as resolve } from '../shared/nuxi.cc8b5ffe.mjs';
import 'node:url';
import 'node:events';
import 'fs';
import 'fs/promises';
import 'events';
import 'path';
import 'stream';
import 'os';
import '../shared/nuxi.6d943677.mjs';
import '../shared/nuxi.deb0a220.mjs';
import './index2.mjs';
import 'node:http';
import 'node:https';
import 'node:net';
import 'node:os';
import '../shared/nuxi.2155838d.mjs';
import 'http';
import 'https';
import '../shared/nuxi.eaa29140.mjs';
import 'node:child_process';
import 'node:fs';
import 'crypto';
import 'node:fs/promises';
import '../shared/nuxi.f56b6a0d.mjs';
import 'node:perf_hooks';
import './satisfies.mjs';
import '../shared/nuxi.00903207.mjs';
import '../shared/nuxi.8054e4da.mjs';
import 'node:module';
import 'node:assert';
import 'node:v8';
import 'module';
import 'perf_hooks';
import 'vm';
import 'url';
import 'assert';
import 'process';
import 'v8';
import 'util';
import 'tty';
import 'node:crypto';
import '../shared/nuxi.15c58622.mjs';
import '../shared/nuxi.c6313488.mjs';
import '../shared/nuxi.fc7ff7ef.mjs';
import '../shared/nuxi.04f089c5.mjs';

const devChild = defineCommand({
  meta: {
    name: "_dev",
    description: "Run Nuxt development server (internal command to start child process)"
  },
  args: {
    ...sharedArgs,
    ...envNameArgs,
    ...legacyRootDirArgs
  },
  async run(ctx) {
    const logger = consola.withTag("nuxi");
    if (!process.send && !C) {
      logger.warn(
        "`nuxi _dev` is an internal command and should not be used directly. Please use `nuxi dev` instead."
      );
    }
    overrideEnv("development");
    const cwd = resolve(ctx.args.cwd || ctx.args.rootDir || ".");
    const devContext = JSON.parse(process.env.__NUXT_DEV__ || "null") || {};
    const nuxtDev = await createNuxtDevServer({
      cwd,
      overrides: ctx.data?.overrides,
      logLevel: ctx.args.logLevel,
      clear: !!ctx.args.clear,
      dotenv: !!ctx.args.dotenv,
      envName: ctx.args.envName,
      port: process.env._PORT ?? void 0,
      devContext
    });
    function sendIPCMessage(message) {
      if (process.send) {
        process.send(message);
      } else {
        logger.info(
          "Dev server event:",
          Object.entries(message).map((e) => e[0] + "=" + JSON.stringify(e[1])).join(" ")
        );
      }
    }
    nuxtDev.on("loading", (message) => {
      sendIPCMessage({ type: "nuxt:internal:dev:loading", message });
    });
    nuxtDev.on("restart", () => {
      sendIPCMessage({ type: "nuxt:internal:dev:restart" });
    });
    nuxtDev.on("ready", (payload) => {
      sendIPCMessage({ type: "nuxt:internal:dev:ready", port: payload.port });
    });
    await nuxtDev.init();
  }
});

export { devChild as default };
